/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

/**
 *
 * @author omozegieaziegbe
 */
import nu.xom.*;

public class XOMInsertNode {

    public static void main(String[] args) {
        try {
            // Sample existing XML string
            String existingXml = "<company><employees></employees></company>";
            
            // Sample new employee XML string
            String newEmployeeXml = "<employee><name>Mr Fish</name><role>Developer</role><salary>75000</salary></employee>";
            
            // Parse the existing XML string into a XOM Document
            Builder parser = new Builder();
            Document existingDocument = parser.build(existingXml, null);
            
            // Parse the new employee XML string into a XOM Document
            Document newEmployeeDocument = parser.build(newEmployeeXml, null);
            
            // Insert the new employee node into the existing document
            insertNodeIntoExistingDocument(existingDocument, newEmployeeDocument);

            // Display the updated XML structure
            System.out.println(existingDocument.toXML());
        } catch (Exception e) {
        }
    }

    /**
     * Inserts the root node of the new Document into an existing Document.
     */
    private static void insertNodeIntoExistingDocument(Document existingDocument, Document newDocument) {
        // Get the root element of the new document (employee node)
        Element newEmployeeElement = newDocument.getRootElement();
        
        // Get the <employees> element from the existing document
        Element employeesElement = existingDocument.getRootElement().getFirstChildElement("employees");

        // Insert the new employee element into the <employees> element
        employeesElement.appendChild(newEmployeeElement.copy());
    }
}
