/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */

package com.jcg;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import java.io.StringReader;
import org.w3c.dom.Element;

/**
 *
 * @author omozegieaziegbe
 */
public class XmlStringToDocument {

    public static void main(String[] args) {
        String xmlString = "<employee>"
                + "<name>Mr Fish</name>"
                + "<role>Developer</role>"
                + "<salary>75000</salary>"
                + "</employee>";
        
        try {
            // Convert the String XML fragment to a Document object
            Document document = convertStringToXMLDocument(xmlString);
            
            // Print the root element to verify
            System.out.println("Root Element: " + document.getDocumentElement().getNodeName());
            
            // Use the Document object to extract and print employee details
            extractAndPrintEmployeeDetails(document);
        } catch (Exception e) {
        }
    }
    
    /**
     * Converts a string containing XML into a Document object.
     */
    private static Document convertStringToXMLDocument(String xmlString) throws Exception {
        // Create a new instance of DocumentBuilderFactory
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        
        // Create a DocumentBuilder instance
        DocumentBuilder builder = factory.newDocumentBuilder();
        
        // Parse the XML string using InputSource and StringReader
        InputSource inputSource = new InputSource(new StringReader(xmlString));
        
        // Return the parsed Document object
        return builder.parse(inputSource);
    }
    
    private static void extractAndPrintEmployeeDetails(Document document) {
        // Get the root element of the XML document
        Element rootElement = document.getDocumentElement();
        
        // Extract elements by tag name
        String name = rootElement.getElementsByTagName("name").item(0).getTextContent();
        String role = rootElement.getElementsByTagName("role").item(0).getTextContent();
        String salary = rootElement.getElementsByTagName("salary").item(0).getTextContent();
        
        // Print extracted values
        System.out.println("Employee Name: " + name);
        System.out.println("Employee Role: " + role);
        System.out.println("Employee Salary: " + salary);
    }
}